#!/usr/bin/bash

### Config section
#Files location
LOCATION_FOLDER={{ svfe_home }}/output/logfiles
DESTINATION_FOLDER=/appdata/archive/logfiles

#Keep files unarchived
KEEP_UNARCHIVE_DAYS=3

#Keep files in LOCATION_FOLDER folder for how many days
KEEP_DAYS=30

#Keep folders in DESTINATION_FOLDER folder for how many months?
KEEP_MONTHS=9

#Temporary file location
TEMP_FILE={{ svfe_home }}/scripts/logfiles_cleanup.tmp

#Work file location (sorted and uniq pairs of files)
WORK_FILE={{ svfe_home }}/scripts/logfiles_cleanup.work

#File to store folders to create
FOLDERS_FILE={{ svfe_home }}/scripts/logfiles_cleanup.folders

#File to store folders to analyze in DESTINATION_FOLDER
ANZ_FILE={{ svfe_home }}/scripts/logfiles_cleanup.anz

### End of config section


check_mount() {
FOLDER_TO_CHECK={{ svfe_home }}
MOUNT_OUT=`mount | grep $FOLDER_TO_CHECK`
RW_RESULT=""
RESULT=""

#check it is mounted
mount | grep $FOLDER_TO_CHECK >/dev/null 2>&1
if [ $? -eq 0 ]
        then
                #Folder is mounted. Perform other checks
                #check if it is ext4
                echo $MOUNT_OUT | grep "type ext4" >/dev/null 2>&1
                if [ $? -eq 0 ]
                        then
                                RESULT=OK
                fi
                #check if it is mounted in read-write mode
                for field in `echo $MOUNT_OUT | awk '{print $6}' | tr ',' ' '`
                        do
                                echo $field | grep rw >/dev/null 2>/dev/null
                                if [ $? -eq 0 ]
                                        then
                                                RW_RESULT=OK
                                fi

                done
                if [ "$RESULT" == "OK" ] && [ "$RW_RESULT" == "OK" ]
                        then
                                return 0
                        else
                                return 100
                fi
        else
                return 100
fi
}

check_mount

if [ $? -ne 0 ]
    then
        echo "SVFE is down here. Nothing to do"
        exit 100
fi


if [ ! -d $DESTINATION_FOLDER ]
    then
        mkdir -p $DESTINATION_FOLDER
fi

# Gzip files

find $LOCATION_FOLDER -type f -mtime +${KEEP_UNARCHIVE_DAYS} ! -name "*.gz" -exec /usr/bin/gzip -9 {} \;

find $LOCATION_FOLDER -type f -mtime +${KEEP_DAYS} > $TEMP_FILE

cat $TEMP_FILE | sed -e 's/.*\///' | sed -e 's/\..*//' |  grep -v '^$' | sort | uniq > $WORK_FILE

#cat $WORK_FILE | cut -d "_" -f 2 | sed -e 's/[0-9]\{2\}$//g' | sort | uniq > $FOLDERS_FILE
cat $WORK_FILE | sed -e 's/[a-zA-Z]*//g' | sed -e 's/^_*//' | cut -d "_" -f 1 | sed -e 's/[0-9]\{2\}$//' | sort | uniq > $FOLDERS_FILE


while read folder_name
    do
        #echo "folder to create: mkdir -p ${DESTINATION_FOLDER}/${folder_name}"
        if [ ! -d ${DESTINATION_FOLDER}/${folder_name} ]
            then
                mkdir -p ${DESTINATION_FOLDER}/${folder_name}
        fi
    done<$FOLDERS_FILE

while read file_name
    do
        #Get folder name to store the file into
        #CURRENT_FOLDER=`echo $file_name | cut -d "_" -f 2 | sed -e 's/[0-9]\{2\}$//g'`
        CURRENT_FOLDER=`echo $file_name | sed -e 's/[a-zA-Z]*//g' | sed -e 's/^_*//' | cut -d "_" -f 1 | sed -e 's/[0-9]\{2\}$//'`

        tar -cvf - -C ${LOCATION_FOLDER} `ls ${LOCATION_FOLDER}/${file_name}* | xargs -I % basename %` | gzip -9 > ${DESTINATION_FOLDER}/${CURRENT_FOLDER}/${file_name}.tar.gz
        ls ${DESTINATION_FOLDER}/${CURRENT_FOLDER}/${file_name}.tar.gz
                if [[ $? == 0 ]]; then
                    rm -f ${LOCATION_FOLDER}/${file_name}*
                fi

    done<$WORK_FILE

### Cleanup destination folder

CURRENT_DATE_YEAR=`date +'%C%y'`
CURRENT_DATE_MONTH=`date +'%m'`

MONTH_SUBSTR=`echo "$CURRENT_DATE_MONTH - $KEEP_MONTHS" | bc`

if [ $MONTH_SUBSTR -eq 0 ]
        then
                DISP_MONTH=12
                DISP_YEAR=`echo "$CURRENT_DATE_YEAR - 1" | bc`
elif [ $MONTH_SUBSTR -gt 0 ]
        then
                DISP_MONTH=$MONTH_SUBSTR
                DISP_YEAR=$CURRENT_DATE_YEAR
elif [ $MONTH_SUBSTR -lt 0 ]
        then
                YEAR_TO_SUBSTR=`echo "sqrt((($MONTH_SUBSTR)/12)^2)" | bc`
                DISP_MONTH=`echo "12 + 12 * $YEAR_TO_SUBSTR - sqrt($MONTH_SUBSTR^2)" | bc`
                DISP_YEAR=`echo "$CURRENT_DATE_YEAR - sqrt((($MONTH_SUBSTR)/12)^2) - 1" | bc`
fi


if [ $DISP_MONTH -lt 10 ]

        then
                DISP_MONTH=0${DISP_MONTH}
fi

#echo "$DISP_YEAR$DISP_MONTH"
DATE_TO_COMPARE=${DISP_YEAR}${DISP_MONTH}

if [ ! -z "$(ls -A $DESTINATION_FOLDER)" ]
        then
                echo "searching in $DESTINATION_FOLDER for folders to cleanup"
                find ${DESTINATION_FOLDER}/* -type d | xargs -I % basename % > $ANZ_FILE

                while read directory_name
                        do
                         #Date to keep till
                           if [ $directory_name -lt $DATE_TO_COMPARE ]
                                 then
                                                echo "Delete ${DESTINATION_FOLDER}/${directory_name}"
                                rm -rf ${DESTINATION_FOLDER}/${directory_name}
                                fi
                        done<$ANZ_FILE

        else
                echo "$DESTINATION_FOLDER is empty"
fi
